
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Approval_reviewersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const approval_reviewers = await db.approval_reviewers.create(
            {
                id: data.id || undefined,
        
        decision: data.decision
        ||
        null
            ,
            
        decided_at: data.decided_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await approval_reviewers.setApproval( data.approval || null, {
            transaction,
        });
        
        await approval_reviewers.setReviewer( data.reviewer || null, {
            transaction,
        });
        
        await approval_reviewers.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return approval_reviewers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const approval_reviewersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                decision: item.decision
            ||
            null
            ,
            
                decided_at: item.decided_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const approval_reviewers = await db.approval_reviewers.bulkCreate(approval_reviewersData, { transaction });

        // For each item created, replace relation files
        

        return approval_reviewers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const approval_reviewers = await db.approval_reviewers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.decision !== undefined) updatePayload.decision = data.decision;
        
        
        if (data.decided_at !== undefined) updatePayload.decided_at = data.decided_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await approval_reviewers.update(updatePayload, {transaction});

        
        
        if (data.approval !== undefined) {
            await approval_reviewers.setApproval(
              
              data.approval,
              
              { transaction }
            );
        }
        
        if (data.reviewer !== undefined) {
            await approval_reviewers.setReviewer(
              
              data.reviewer,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await approval_reviewers.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return approval_reviewers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const approval_reviewers = await db.approval_reviewers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of approval_reviewers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of approval_reviewers) {
                await record.destroy({transaction});
            }
        });


        return approval_reviewers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const approval_reviewers = await db.approval_reviewers.findByPk(id, options);

        await approval_reviewers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await approval_reviewers.destroy({
            transaction
        });

        return approval_reviewers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const approval_reviewers = await db.approval_reviewers.findOne(
            { where },
            { transaction },
        );

        if (!approval_reviewers) {
            return approval_reviewers;
        }

        const output = approval_reviewers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.approval = await approval_reviewers.getApproval({
            transaction
        });
        
        
        output.reviewer = await approval_reviewers.getReviewer({
            transaction
        });
        
        
        output.organizations = await approval_reviewers.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.approvals,
        as: 'approval',
        
        where: filter.approval ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approval.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.approval.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reviewer',
        
        where: filter.reviewer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reviewer.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reviewer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.decided_atRange) {
                const [start, end] = filter.decided_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    decided_at: {
                    ...where.decided_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    decided_at: {
                    ...where.decided_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.decision) {
                where = {
                    ...where,
                decision: filter.decision,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.approval_reviewers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'approval_reviewers',
                        'decision',
                        query,
                    ),
                ],
            };
        }

        const records = await db.approval_reviewers.findAll({
            attributes: [ 'id', 'decision' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['decision', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.decision,
        }));
    }

    
};

